<script lang="ts">
	import { Pie } from "svelte-chartjs";
	import type { ChartData, ChartOptions } from "chart.js/auto";
	import "chart.js/auto";
	import type { ActionData, Actions, PageData, PageServerData } from "./$types";
	import TransactionCard from "@/components/TransactionCard.svelte";
	import { Button, Card, Divider, H1, H3, Loading, Modal } from "attractions";
	import type { Account, Bankcard, Spending, Transaction } from "@/utils/types";
	import TransactionDetails from "@/components/TransactionDetails.svelte";
	import TransferDialog from "@/components/TransferDialog.svelte";
	import CategoryEdit from "@/components/CategoryEdit.svelte";
	import AccountCard from "@/components/AccountCard.svelte";
	import RenameDialog from "@/components/RenameDialog.svelte";
	import moment from "moment";
    import AccountDialog from "@/components/AccountDialog.svelte";
	import { API_URL, FETCH_OPTIONS } from "@/utils/constants";
    import BankcardCard from "@/components/BankcardCard.svelte";
    import BankcardDialog from "@/components/BankcardDialog.svelte";

	// export let data: PageData & PageServerData;
	export let form: ActionData;

	let selected_account: Account;
	let accounts: Account[] = [];
	async function load_accounts() {
		let response = await fetch(`${API_URL}/account/get`, { ...FETCH_OPTIONS, method: "GET" });
		let json = await response.json();
		({ accounts } = json);

		selected_account ??= accounts?.[0];
	}
	let accounts_promise = load_accounts();

	let cards: Bankcard[] = [];
	async function load_cards() {
		await accounts_promise;

		let request_body = JSON.stringify({
			account_number: selected_account?.number
		});

		({ cards } = await (
			await fetch(`${API_URL}/card/get`, {
				...FETCH_OPTIONS,
				method: "POST",
				body: request_body,
			})
		).json());
	}
	let cards_promise = load_cards();

	let spendings: Spending[] = [];
	async function load_spendings() {
		await accounts_promise; // Wait for the accounts to load

		let request_body = JSON.stringify({
			account_number: selected_account?.number,
			start_date: moment().startOf("month").format("YYYY-MM-DD"),
			end_date: moment().endOf("month").format("YYYY-MM-DD"),
		});

		({ spendings } = await (
			await fetch(`${API_URL}/account/spending`, {
				...FETCH_OPTIONS,
				method: "POST",
				body: request_body,
			})
		).json());
	}
	let spendings_promise = load_spendings();

	let transactions: Transaction[] = [];
	async function load_transactions() {
		await accounts_promise;

		let request_body = JSON.stringify({
			account_number: selected_account?.number,
			start_date: moment().startOf("month").format("YYYY-MM-DD"),
			end_date: moment().endOf("month").format("YYYY-MM-DD"),
		});

		({ transactions } = await (
			await fetch(`${API_URL}/transaction/get`, {
				...FETCH_OPTIONS,
				method: "POST",
				body: request_body,
			})
		).json());
	}
	let transactions_promise = load_transactions();

	async function load_data(account = false) {
		if (account) accounts_promise = load_accounts();
		cards_promise = load_cards();
		spendings_promise = load_spendings();
		transactions_promise = load_transactions();
	}

	$: options = {
		plugins: {
			title: {
				display: true,
				fullSize: true,
				font: {
					size: 24,
					family: "Roboto",
					weight: "normal",
					lineHeight: 1.4,
				},
				text: [
					`Eddigi költés`,
					`${spendings.reduce((prev, curr) => (prev += curr.spending), 0)} Ft`,
				],
			},
			legend: {
				align: "center",
				position: "top",
			},
			tooltip: {
				callbacks: {
					label: (tooltipItem) => {
						return tooltipItem.formattedValue + " Ft";
					},
				},
			},
		},
	} as ChartOptions;
	$: chart_data = {
		labels: spendings.map((s) => s.category),
		datasets: [
			{
				data: spendings.map((s) => Number(s.spending)),
				backgroundColor: [
					"rgba(255, 134,159,0.6)",
					"rgba(98,  182, 239,0.6)",
					"rgba(255, 218, 128,0.6)",
					"rgba(113, 205, 205,0.6)",
					"rgba(170, 128, 252,0.6)",
					"rgba(255, 177, 101,0.6)",
				],
				borderWidth: 2,
				borderColor: [
					"rgba(255, 134, 159, 1)",
					"rgba(98,  182, 239, 1)",
					"rgba(255, 218, 128, 1)",
					"rgba(113, 205, 205, 1)",
					"rgba(170, 128, 252, 1)",
					"rgba(255, 177, 101, 1)",
				],
			},
		],
	} as ChartData;

	let transfer_modal = false;

	let account_modal = false;

	let card_modal = false;

	let details_modal = false;
	let selected_transaction: Transaction | undefined = undefined;

	let edit_category_modal = false;
	let edit_category_transaction: Transaction | undefined = undefined;

	let edit_account_modal = false;
	let edit_account: Account | undefined = undefined;

	$: if (form?.success) {
		transfer_modal = false;
		account_modal = false;
		card_modal = false;
		edit_category_modal = false;
		edit_account_modal = false;
		load_data();
	}
</script>

<div class="wrapper">
	<Modal bind:open={edit_category_modal} let:closeCallback>
		<CategoryEdit {closeCallback} transaction={edit_category_transaction} />
	</Modal>

	<Modal bind:open={details_modal} let:closeCallback>
		<TransactionDetails
			{closeCallback}
			transaction={selected_transaction}
			on:edit_category={(e) => {
				edit_category_transaction = e.detail;
				edit_category_modal = true;
				details_modal = false;
			}}
		/>
	</Modal>

	<Modal bind:open={transfer_modal} let:closeCallback>
		<TransferDialog {closeCallback} sender_account={selected_account} form_action="?/add_transaction" />
	</Modal>

	<Modal bind:open={card_modal} let:closeCallback>
		<BankcardDialog {closeCallback} account={selected_account} form_action="?/add_card"/>
	</Modal>

	<Modal bind:open={account_modal} let:closeCallback>
		<AccountDialog {closeCallback} on:reload_data={() => {load_data(true); account_modal = false;}}/>
	</Modal>

	<Modal bind:open={edit_account_modal} let:closeCallback>
		<RenameDialog {closeCallback} account={edit_account} form_action="?/edit_account_name" />
	</Modal>
	<div class="left-pane">
		<div class="accounts">
			{#await accounts_promise}
				<Loading />
			{:then}
				<div class="account-cards">
					{#each accounts as account}
						<AccountCard
							{account}
							selected={account.number == selected_account?.number}
							on:click={async (e) => {
								selected_account = e.detail;
								await load_data()
							}}
							on:edit={(e) => {
								edit_account = e.detail;
								edit_account_modal = true;
							}}
						/>
					{/each}
				</div>
			{:catch e}
				{e}
			{/await}
			<Button on:click={() => { account_modal = true; }}>
				<i class="material-icons">add</i>
				Új számla
			</Button>
		</div>
		<div class="bank-cards">
			{#await cards_promise}
				<Loading />
			{:then}
				<div class="account-cards">
					{#each cards as card}
						<BankcardCard
							{card}
							on:update_data ={() => load_data()}
						/>
					{/each}
				</div>
			{:catch e}
				{e}
			{/await}
			<Button on:click={() => { card_modal = true; }} style="margin-bottom: 12px">
				<i class="material-icons">add_card</i>
				Új bankkártya
			</Button>
		</div>
	</div>

	<div class="chart">
		{#await spendings_promise}
			<Loading />
		{:then}
			<Pie data={chart_data} {options} />
		{:catch e}
			{e}
		{/await}
	</div>

	<div class="transactions">
		<Button
			on:click={() => {
				transfer_modal = true;
			}}
		>
			<i class="material-icons">add</i>
			Utalás
		</Button>
		<div class="scroll-container">
			{#await transactions_promise}
				<Loading />
			{:then}
				{#each transactions as transaction}
					<TransactionCard
						{transaction}
						on:click={(e) => {
							selected_transaction = e.detail;
							details_modal = true;
						}}
					/>
				{/each}
			{/await}
		</div>
	</div>
</div>

<style>
	.wrapper {
		width: 100%;
		height: 100%;
		display: grid;
		grid-template-columns: 1fr auto 1fr;
		align-items: center;
		justify-content: center;
	}
	
	.scroll-container {
		display: flex;
		flex-direction: column;
		padding: 12px;
		row-gap: 12px;
		overflow: auto;
		max-height: 600px;
	}

	.transactions {
		display: flex;
		flex-direction: column;
		align-items: center;
	}

	.chart {
		width: 500px;
	}

	.left-pane {
		height: 100%;
		display: grid;
		grid-template-columns: 1fr;
		grid-template-rows: 1fr 1fr;
	}

	.accounts {
		display: grid;
		grid-template-rows: 1fr min-content;
		row-gap: 12px;
		justify-items: center;
	}

	.bank-cards {
		display: grid;
		grid-template-rows: 1fr min-content;
		justify-items: center;
	}

	.account-cards {
		display: flex;
		flex-direction: column;
		row-gap: 12px;
		height: 350px;
		padding: 12px 24px;
		margin-top: 12px;
		overflow-x: hidden;
		overflow-y: auto;
	}
</style>
